{
===============================================================================
  Copyright (©) 2007. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 
  Versión actual: 1.0.0
  Fecha versión actual: 
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit uDataModuleTiposIVA;

interface

uses
  SysUtils, Classes, DB, uDAClientDataModule, uDADataTable, uDABINAdapter,
  uDAScriptingProvider, uDACDSDataTable, uROWinInetHttpChannel, uROTypes,
  uROServiceComponent, uRORemoteService, uROClient, uROBinMessage,
  uDADesigntimeCall,

  uIDataModuleTiposIVA, uBizTiposIVA;

type
  TDataModuleTiposIVA = class(TDAClientDataModule, IDataModuleTiposIVA)
    RORemoteService: TRORemoteService;
    DABinAdapter: TDABINAdapter;
    DADesigntimeCall1: TDADesigntimeCall;
    LoginRemoteService: TRORemoteService;
    ROWinInetHTTPChannel1: TROWinInetHTTPChannel;
    ROBinMessage1: TROBinMessage;
    tbl_TiposIVA: TDACDSDataTable;
    ds_TiposIVA: TDADataSource;
    procedure DAClientDataModuleCreate(Sender: TObject);
  protected
    function DarNombreGenerador(DataSetName: String): String; virtual;
    function _CloneDataTable (const ADataTable : TDACDSDataTable): TDACDSDataTable; overload;
    
    // Descomentar si tiene detalles
    // function _GetDetalles: IBizDetalles;
  public
    function GetNextID(const DataSetName : String) : Integer;
    function GetItems: IBizTipoIVA;
    function GetItem(const ID : Integer) : IBizTipoIVA;
    function NewItem : IBizTipoIVA;

    // Descomentar si tiene informe
    // function GetReport(const ATipoIVAID: Integer): Binary;
    
  end;

implementation

{$R *.DFM}

uses
  FactuGES_Intf, uDataModuleConexion, uDataTableUtils, cxControls, uDAInterfaces,
  schTiposIVAClient_Intf;

{ TDataModuleTiposIVA }


// Descomentar si tiene informe
// function TDataModuleTiposIVA.GetReport(const ATipoIVAID: Integer): Binary;
// begin
//   Result := (RORemoteService as IsrvTiposIVA).GenerateReport(ATipoIVAID)
// end;

procedure TDataModuleTiposIVA.DAClientDataModuleCreate(Sender: TObject);
begin
  RORemoteService.Channel := dmConexion.Channel;
  RORemoteService.Message := dmConexion.Message;
end;

function TDataModuleTiposIVA.DarNombreGenerador(DataSetName: String): String;
begin
  Result := '';
  if DataSetName = nme_TiposIVA then
    Result := 'GEN_TIPOS_IVA_ID'
end;

function TDataModuleTiposIVA.GetNextID(const DataSetName: String): Integer;
var
  aGeneratorName : String;
begin
  aGeneratorName := DarNombreGenerador(DataSetName);
  Result := (RORemoteService as IsrvTiposIVA).GetNextAutoInc(aGeneratorName)
end;

function TDataModuleTiposIVA._CloneDataTable(const ADataTable : TDACDSDataTable): TDACDSDataTable;
begin
  Result := NIL;

  if not Assigned(ADataTable) then
    raise Exception.Create ('No se ha asignado la tabla de origen (CloneDataTable)');

  Result := TDACDSDataTable.Create(NIL);
  CloneDataTable(ADataTable, Result);
end;


// Descomentar si tiene detalles
// function TDataModuleTiposIVA._GetDetalles: IBizTipoIVADetalles;
// var
//   ADetalles : TDACDSDataTable;
// begin
//   ShowHourglassCursor;
//   try
//     ADetalles := _CloneDataTable(tbl_TiposIVADetalles);
//     with ADetalles do
//     begin
//       BusinessRulesID := BIZ_CLIENT_TipoIVADETALLES;
//       DetailOptions := DetailOptions -
//         [dtDisableLogOfCascadeDeletes, dtDisableLogOfCascadeUpdates];
//     end;
//     Result := (ADetalles as IBizTipoIVADetalles);
//   finally
//     HideHourglassCursor;
//   end;
// end;


function TDataModuleTiposIVA.GetItems: IBizTipoIVA;
var
  ATipoIVA : TDACDSDataTable;
begin
  ShowHourglassCursor;
  try
    ATipoIVA := _CloneDataTable(tbl_TiposIVA);
    ATipoIVA.BusinessRulesID := BIZ_CLIENT_TipoIVA;

		// Descomentar si tiene detalles
    // with TBizTipoIVA(ATipoIVA.BusinessEventsObj) do
    //  Detalles := _GetDetalles;

    Result := (ATipoIVA as IBizTipoIVA);
  finally
    HideHourglassCursor;
  end;
end;

function TDataModuleTiposIVA.NewItem: IBizTipoIVA;
begin
  Result := GetItem(ID_NULO)
end;

function TDataModuleTiposIVA.GetItem(const ID: Integer): IBizTipoIVA;
begin
  ShowHourglassCursor;
  try
    Result := Self.GetItems;
    with Result.DataTable.Where do
    begin
      if NotEmpty then
        AddOperator(opAND);
      OpenBraket;
      AddText('TIPOS_IVA.' + fld_TiposIVAID + ' = ' + IntToStr(ID));
      CloseBraket;
    end;
  finally
    HideHourglassCursor;
  end;
end;

end.
